#[doc = "Register `SOF1` reader"]
pub struct R(crate::R<SOF1_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<SOF1_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<SOF1_SPEC>> for R {
    fn from(reader: crate::R<SOF1_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `SOF1` writer"]
pub struct W(crate::W<SOF1_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<SOF1_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<SOF1_SPEC>> for W {
    fn from(writer: crate::W<SOF1_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `FRAME_NUMBER_MSB` reader - It has the upper 3 bits \\[10:8\\]
of the SOF frame number."]
pub struct FRAME_NUMBER_MSB_R(crate::FieldReader<u8, u8>);
impl FRAME_NUMBER_MSB_R {
    pub(crate) fn new(bits: u8) -> Self {
        FRAME_NUMBER_MSB_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for FRAME_NUMBER_MSB_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl R {
    #[doc = "Bits 0:2 - It has the upper 3 bits \\[10:8\\]
of the SOF frame number."]
    #[inline(always)]
    pub fn frame_number_msb(&self) -> FRAME_NUMBER_MSB_R {
        FRAME_NUMBER_MSB_R::new((self.bits & 0x07) as u8)
    }
}
impl W {
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Start Of Frame Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [sof1](index.html) module"]
pub struct SOF1_SPEC;
impl crate::RegisterSpec for SOF1_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [sof1::R](R) reader structure"]
impl crate::Readable for SOF1_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [sof1::W](W) writer structure"]
impl crate::Writable for SOF1_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets SOF1 to value 0"]
impl crate::Resettable for SOF1_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
